using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Windows.Forms.Grid;
using System.Runtime.Serialization;
using System.Drawing;
using Syncfusion.Windows.Forms.Grid.Grouping ;   

namespace GGC_Sample1
{

    [Serializable]
    public class CustomCellModel : GridTextBoxCellModel
    {
        protected CustomCellModel(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public CustomCellModel(GridModel grid)
            : base(grid)
        {
        }

        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new CustomCellRenderer(control, this);
        }
    }

    public class CustomCellRenderer : GridTextBoxCellRenderer
    {
        #region Data Members

        GridCellModelBase m_Model;
        Size m_ButtonBarSize = Size.Empty;


        #endregion // Data Members

        public CustomCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
            m_Model = cellModel;
        }

        protected override bool OnSaveChanges()
        {
            GridTableControl tc = this.Grid as GridTableControl;
            GridTableCellStyleInfo info = this.Grid.Model[RowIndex, ColIndex] as GridTableCellStyleInfo;
            ICustomObject typedValue = this.Grid.Model[RowIndex, ColIndex].CellValue as ICustomObject;
            if (typedValue != null)
            {
                if (tc != null && info.TableCellIdentity.DisplayElement.Kind == Syncfusion.Grouping.DisplayElementKind.AddNewRecord)
                    tc.Table.AddNew();

                ICustomObject objBaseForClass = Activator.CreateInstance(typedValue.GetType()) as ICustomObject;
                objBaseForClass.DoubleValue = Convert.ToDouble(this.ControlText);
                ControlValue = typedValue;
                this.Grid.Model[RowIndex, ColIndex].CellValue = objBaseForClass;
                CurrentCell.IsModified = false;
                return true;
            }
            else
                return false;
        }
        
    }


}
